// Met de variable 'speakerPin' bepaal je aan welke pin de buzzer verbindt op de Arduino Uno.
int speakerPin = 10;
// Met de variable 'tones' bepaal je de toonhoogte die de buzzer afspeelt. De waarde van deze variabele is willekeurig voor een organisch gevoel.
int tones = int(random(1400, 1700));

#include <Servo.h>
// Bepaal welke servomotor er wordt aangeroepen.
Servo servo1;
// Met de variable 'servoPos' bepaal je de positie, dus de draai, van de servomotor.
int servoPos = 0;

void setup() 
{
  Serial.begin(9600);
  
// Bodemvochigheidssensor als input op A0.
  pinMode(A0, INPUT);
}

void loop() 
{
// Met de variabele 'sensorValue' kun je de input van de sensor meten.
  int sensorValue = analogRead(A0);
// De variable 'sensorValue' map je van 500 als laagste waarde tot 1023 als hoogste waarde naar 0 als laagste waarde tot 2 als hoogste waarde.
// Test voor het mappen zelf eerst de sensor uit. Gebruik hierbij de functie 'Serial.println(sensorValue);'. Pas de afgelezen waardes toe op de map.
// Deze waarde wordt gegeven aan de variable 'isDry'. Als 'isDry' gelijk is aan 0 is de bodem nat, bij 1 droger en bij 2 erg droog.
  int isDry = map(sensorValue, 500, 1023, 0, 2);

// If-statement: 'Als 'isDry' groter is dan 0, dus als de bodem droger of droog is, voer dan deze functies uit:'
  if(isDry > 0)
  {
    // Schakel de servomotor aan.
    servo1.attach(9);
    // Voer de functie 'buzzer uit'.
    buzzer();
    // Speel op de buzzer met de pin 'speakerPin' de toonhoogte 'tones' af.
    tone(speakerPin, tones);
    // Draai de servomotor naar positie 'servoPos'.
    servo1.write(servoPos); 
  } 
  // Else: 'In alle andere gevallen, dus als 'isDry' gelijk is aan 0, voer dan deze functies uit:'
  else 
  {
    // Speel op de buzzer met de pin 'speakerPin' geen toon af.
    noTone(speakerPin);
    // Schakel de servomotor uit.
    servo1.detach();
  }
}

// Met de functie 'buzzer' bepaal je de eigenschappen van de toon de die buzzer afspeelt.
// Iedere waarde van iedere variabele wordt steeds willekeurig uitgekozen. Hierdoor voelt het eindproduct organisch en levendig.
void buzzer()
{ 
  // Met de variabele 'toneDuration' bepaal je hoe lang een toon duurt.
  // 'toneDuration' werkt eigenlijk als een maximale toonhoogte. 
  int toneDuration = int(random(2500, 3300));
  // Met de variabele 'toneBreak' bepaal je hoe lang de pauzes tussen de tonen duren.
  int toneBreak = int(random(500, 2000));
  // Met de float variabele 'tonesAdd' bepaal je de toonverhoging.
  float tonesAdd = 1.01 + random(0, 0.02);
  
  // Met deze functie reken je de verhoging van de toon uit. Deze functie rekent steeds verder op de vorige uitkomst van 'tones'. 
  // Hierdoor klinken de tonen alsof ze verhogen, dus als vogelpiepjes.
  tones = tones * tonesAdd;
  // Hiermee kun je de toonhoogte aflezen in de Serial Monitor.
  Serial.println(tones);
  
  // Met deze if-statement zorg je dat er na iedere piep een pauze afspeelt. 
  // Ook zorgt deze if-statement ervoor dat er na iedere pauze een nieuw piepje afspeelt.
  // If-statement: 'Als 'tones'(de huidige toonhoogte) hoger is dan 'toneDuration' (de maximale toonhoogte), voer dan deze functies uit:'
  if(tones >= toneDuration)
  {
    // Speel op de buzzer met de pin 'speakerPin' geen toon af.
    noTone(speakerPin);
    // Start de pauze: 'pauzeer het programma voor 'toneBreak'.'
    delay(toneBreak);
    // Start de nieuwe toon na de pauze. Pak hierbij een willekeurige toonhoogte.
    tones = int(random(1400, 1700));
    // Bepaal hoe lang de volgende pauze duurt. Pak hierbij een willekeurige pauzelengte.  
    toneBreak = int(random(500,2000));
    // Draai de servomotor naar een nieuwe willekeurige positie.
    servoPos = random(0, 180);
  }
}
